/* ystcpApi.c: TCP/IP@\DLLĂяoC^tF[XvO	*/
/* Copyright (c) yma system lab. 2006										*/
#include <windows.h>
#include <stdio.h>

#define	DLLNAME		"ystcpFunc.dll"
typedef void  (__cdecl *logTrace) (char *tcp, char *msg, int code);
typedef void  (__cdecl *logInfo)  (char *tcp, char *msg, int code);
typedef void  (__cdecl *logError) (char *tcp, char *msg, int code);
typedef char* (__cdecl *clInit) (int bufsize,
								char *logdir, char *logfile, int loglevel);
typedef int   (__cdecl *clConnect) (char *tcp, char *host, int port, int time);
typedef int   (__cdecl *clSend) (char *tcp, char *data, int datalen);
typedef char* (__cdecl *clRecv) (char *tcp, int time, int *recvsize);
typedef void  (__cdecl *clDisconnect) (char *tcp);
typedef void  (__cdecl *clTerm) (char *tcp);

typedef char* (__cdecl *svInit) (int port, int bufsize,
								 char *logdir, char *logfile, int loglevel);
typedef char* (__cdecl *svAccept) (char *svtcp);
typedef int   (__cdecl *svSend) (char *actcp, char *data, int datalen);
typedef char* (__cdecl *svRecv) (char *actcp, int time, int *recvsize);
typedef void  (__cdecl *svClose) (char *actcp);
typedef void  (__cdecl *svTerm) (char *svtcp);

HINSTANCE	hDll			= NULL;
FARPROC		prTrace			= NULL;
FARPROC		prInfo			= NULL;
FARPROC		prError			= NULL;

FARPROC		prClInit		= NULL;
FARPROC		prClConnect		= NULL;
FARPROC		prClSend		= NULL;
FARPROC		prClRecv		= NULL;
FARPROC		prClDisconnect	= NULL;
FARPROC		prClTerm		= NULL;

FARPROC		prSvInit		= NULL;
FARPROC		prSvAccept		= NULL;
FARPROC		prSvSend		= NULL;
FARPROC		prSvRecv		= NULL;
FARPROC		prSvClose		= NULL;
FARPROC		prSvTerm		= NULL;

int tcpLoadLib() {
	int		retcode	= 0;

    if ((hDll = LoadLibrary(DLLNAME)) == NULL) retcode = -1;
	else if ((prTrace      = GetProcAddress(hDll, "logTrace")) == NULL) retcode = -2;
	else if ((prInfo       = GetProcAddress(hDll, "logInfo"))  == NULL) retcode = -3;
	else if ((prError      = GetProcAddress(hDll, "logError")) == NULL) retcode = -4;

	else if ((prClInit       = GetProcAddress(hDll, "clInit"))       == NULL) retcode = -10;
	else if ((prClConnect    = GetProcAddress(hDll, "clConnect"))    == NULL) retcode = -11;
	else if ((prClSend       = GetProcAddress(hDll, "clSend"))       == NULL) retcode = -12;
	else if ((prClRecv       = GetProcAddress(hDll, "clRecv"))       == NULL) retcode = -13;
	else if ((prClDisconnect = GetProcAddress(hDll, "clDisconnect")) == NULL) retcode = -14;
	else if ((prClTerm       = GetProcAddress(hDll, "clTerm"))       == NULL) retcode = -15;

	else if ((prSvInit   = GetProcAddress(hDll, "svInit"))   == NULL) retcode = -20;
	else if ((prSvAccept = GetProcAddress(hDll, "svAccept")) == NULL) retcode = -21;
	else if ((prSvSend   = GetProcAddress(hDll, "svSend"))   == NULL) retcode = -22;
	else if ((prSvRecv   = GetProcAddress(hDll, "svRecv"))   == NULL) retcode = -23;
	else if ((prSvClose  = GetProcAddress(hDll, "svClose"))  == NULL) retcode = -24;
	else if ((prSvTerm   = GetProcAddress(hDll, "svTerm"))   == NULL) retcode = -25;

	if ((retcode != 0) && (hDll != NULL)) {
		FreeLibrary(hDll);
		hDll = NULL;
	}
	return retcode;
}
void tcpFreeLib() {
	FreeLibrary(hDll);
	hDll = NULL;
}
void tcpLogTrace(char *tcp, char *msg, int code) {
	(*(logTrace)prTrace) (tcp, msg, code);
}
void tcpLogInfo(char *tcp, char *msg, int code) {
	(*(logInfo)prInfo) (tcp, msg, code);
}
void tcpLogError(char *tcp, char *msg, int code) {
	(*(logError)prError) (tcp, msg, code);
}
char *tcpClInit(int bufsize, char *logdir, char *logfile, int loglevel) {
	return (*(clInit)prClInit) (bufsize, logdir, logfile, loglevel);/* NCAg	*/
}
int  tcpClConnect(char *tcp, char *hostname, int port, int time) {
	return (*(clConnect)prClConnect) (tcp, hostname, port, time);	/* T[o[Ɛڑ	*/
}
int  tcpClSend(char *tcp, char *data, int datalen) {
	return (*(clSend)prClSend) (tcp, data, datalen);				/* f[^̑M		*/
}
char *tcpClRecv(char *tcp, int time, int *recvsize) {
	return (*(clRecv)prClRecv) (tcp, time, recvsize);				/* f[^̎M		*/
}
void tcpClDisconnect(char *tcp) {
	(*(clDisconnect)prClDisconnect) (tcp);							/* ڑJ		*/
}
void tcpClTerm(char *tcp) {
	(*(clTerm)prClTerm) (tcp);										/* ʐM	*/
}

char *tcpSvInit(int port, int bufsize, char *logdir, char *logfile, int loglevel) {
	return (*(svInit)prSvInit) (port, bufsize, logdir, logfile, loglevel);/* T[o	*/
}
char *tcpSvAccept(char *svtcp) {
	return (*(svAccept)prSvAccept) (svtcp);							/* accepts		*/
}
int  tcpSvSend(char *actcp, char *data, int datalen) {
	return (*(svSend)prSvSend) (actcp, data, datalen);				/* f[^̑M		*/
}
char *tcpSvRecv(char *actcp, int time, int *recvsize) {
	return (*(svRecv)prSvRecv) (actcp, time, recvsize);				/* f[^̎M		*/
}
void tcpSvClose(char *actcp) {
	(*(svClose)prSvClose) (actcp);									/* accept̉	*/
}
void tcpSvTerm(char *svtcp) {
	(*(svTerm)prSvTerm) (svtcp);									/* ʐM̉	*/
}
